
Partial Class FinancialCalculator
    Inherits System.Web.UI.Page

    Protected Sub performCalc_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles performCalc.Click
        'Specify constant values
        Const INTEREST_CALCS_PER_YEAR As Integer = 12
        Const PAYMENTS_PER_YEAR As Integer = 12

        'Create variables to hold the values entered by the user
        Dim P As Double = loanAmount.Text
        Dim r As Double = rate.Text / 100
        Dim t As Double = mortgageLength.Text

        Dim ratePerPeriod As Double
        ratePerPeriod = r / INTEREST_CALCS_PER_YEAR

        Dim payPeriods As Integer
        payPeriods = t * PAYMENTS_PER_YEAR

        Dim annualRate As Double
        annualRate = Math.Exp(INTEREST_CALCS_PER_YEAR * Math.Log(1 + ratePerPeriod)) - 1

        Dim intPerPayment As Double
        intPerPayment = (Math.Exp(Math.Log(annualRate + 1) / payPeriods) - 1) * payPeriods

        'Now, compute the total cost of the loan
        Dim intPerMonth As Double = intPerPayment / PAYMENTS_PER_YEAR

        Dim costPerMonth As Double
        costPerMonth = P * intPerMonth / (1 - Math.Pow(intPerMonth + 1, -payPeriods))


        'Now, display the results in the results Label Web control
        results.Text = "Your mortgage payment per month is $" & costPerMonth
    End Sub
End Class
